//*******************************************************************************
//                   StickSlip SCICOS Simulationblock
//*******************************************************************************
// by Weichinger Klaus - last modification 2008-06-21
// EMail: snaky.1@gmx.at             ICQ:   120410945
// License: Creative Commons Attribution 3.0 Unported
//          You are free:
//             - to Share
//             - to Remix
//          Under the following conditions:
//             - Attribution
//     See
//         http://creativecommons.org/licenses/by/3.0
//     for more details.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//*******************************************************************************

function [x,y,typ]=StickSlipSys(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
    case 'plot' then
      standard_draw(arg1)
    case 'getinputs' then
      [x,y,typ]=standard_inputs(arg1)
    case 'getoutputs' then
      [x,y,typ]=standard_outputs(arg1)
    case 'getorigin' then
      [x,y]=standard_origin(arg1)
    case 'set' then
      x=arg1;
      graphics=arg1.graphics;exprs=graphics.exprs;
      model=arg1.model;
      while %t do
        [ok,sv,sf,kf,ldc,x0,exprs]=..
          getvalue('Stick Slip System',..
                   ['stribeck velocity',..
                    'static friction',..
                    'kinetic friction',..
                    'linear damping coefficient',..
                    'initial condition'],..
                   list('vec',1,'vec',1,'vec',1,'vec',1,'vec',2),exprs);
        if ~ok then break, end
        evtin=[];
        evtout=[];
        in=[1];
        out=[1;1;1];
        [model,graphics,ok]=check_io(model,graphics,in,out,evtin,evtout)
        if ok then
          model.state=x0(:);
          model.rpar=[sv,sf,kf,ldc]
          model.ipar=[]
          graphics.exprs=exprs
          x.graphics=graphics
          x.model=model
          break
        end
      end
    case 'define' then
      sv=0;
      sf=1.2;
      kf=1;
      ldc=0.1;
      x0=[0;0];
      model=scicos_model();
      model.sim=list('cfStickSlipSys',5);
      model.evtin=[];
      model.in=[1];
      model.out=[1;1;1];
      model.state=x0(:);
      model.nzcross=3;
      model.nmode=0;
      model.blocktype='c';
      model.dep_ut=[%f %t];
      model.rpar=[sv,sf,kf,ldc];
      model.ipar=[];
      exprs=[sci2exp(sv),..
             sci2exp(sf),..
             sci2exp(kf),..
             sci2exp(ldc),..
             sci2exp(x0)];
      gr_i=['txt=[''StickSlipSys''];';..
            'xstringb(orig(1),orig(2),txt,sz(1),sz(2),''fill'')'];
      x=standard_define([4 2],model,exprs,gr_i);
  end      
endfunction
