//*******************************************************************************
//                   StickSlip SCICOS Simulationblock
//*******************************************************************************
// by Weichinger Klaus - last modification 2008-06-21
// EMail: snaky.1@gmx.at             ICQ:   120410945
// License: Creative Commons Attribution 3.0 Unported
//          You are free:
//             - to Share
//             - to Remix
//          Under the following conditions:
//             - Attribution
//     See
//         http://creativecommons.org/licenses/by/3.0
//     for more details.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//*******************************************************************************

function block=cfStickSlipSys(block,flag)
  sv=block.rpar(1);
  sf=block.rpar(2);
  kf=block.rpar(3);
  ldc=block.rpar(4);
  
  phase=phase_simulation();

  if flag==0 then // Zustand aktualisieren
    x=block.x(1);
    v=block.x(2);
    F=block.inptr(1);

    if (sf==0) then
      // System ohne Reibmodell
      block.xd(1)=v;
      block.xd(2)=F;
    else
      if (v==0)&(abs(F)<=abs(sf)) then
        // System bleibt haften
        block.xd(1)=0;
        block.xd(2)=0;
      else
        // System gleitet
        // Reibmodell
        if (sv>0) then
	        Fr=ldc*v+(kf+(sf-kf)*exp(-(abs(v)/sv)))*sign(v);
	      else
	        Fr=ldc*v+kf*sign(v);
	      end
        block.xd(1)=v;
        block.xd(2)=F-Fr;
      end
    end
  end

  if flag==1 then // Ausgnge berechnen
    x=block.x(1);
    v=block.x(2);  
    block.outptr(1)=block.x(1);
    block.outptr(2)=block.x(2);
    if (v==0) then
      block.outptr(3)=0;
    else
      block.outptr(3)=1;
    end
  end

  if (flag==2)&(block.nevprt==-1) then // Zero-Crossing wurde festgestellt
    if (block.jroot(1)<>0) then // Zero-Crossing fr Geschwindigkeit Effekt
      block.x(2)=0;
    end
    if (block.jroot(2)>0) then // Zero-Crossing fr die Eingangskraft
      block.x(2)=0;
    end
    if (block.jroot(3)<0) then // Zero-Crossing fr die Eingangskraft
      block.x(2)=0;
    end
  end

  if flag==4 then // Initialisierung
 
  end

  if flag==5 then // Ende Simulation
  end

  if flag==9 then // Zero-Crossing Surfaces berechnen
    F=block.inptr(1);  
    block.g(1)=block.x(2);
    block.g(2)=F-sf;
    block.g(3)=F+sf;
  end
endfunction
